define([
    'jquery',
    'matchMedia',
    'lazyload',
    'plyr',
    'jquery/ui',
    'swiper_4_0_6'
], function ($, mediaCheck, lazy, plyr, ui, Swiper) {
    'use strict';

    $.widget('filoblu.categorySliderWidget', {

        _create: function () {

            var self = this,
                categorySliderType = self.options.type,
                categorySlider = $('.category-slider-container', self.element),
                categorySliderJsId = self.options.jsObjectId;

            if ($('.swiper-slide', categorySlider).length > 1) {

                switch (categorySliderType) {

                    case 'side-title':
                        self.initSideTitleSlider(categorySlider,categorySliderJsId,self);
                        break;

                    case 'top-title':
                        self.initTopTitleSlider(categorySlider,categorySliderJsId,self);
                        break;

                    case 'big-title':
                        self.initBigImageSlider(categorySlider,categorySliderJsId,self);
                        break;

                    default:
                        console.log('Unknow category slider type');
                        return;
                }
            }


            $(window).on('resize',function(){

            });
        },

        initSideTitleSlider: function (slider,sliderId,self) {
            var sideTtileCategorySlider = new Swiper(slider,{
                spaceBetween: 20,
                slidesPerView: 3,
                slidesPerGroup: 1,
                navigation:{
                    prevEl: self.options.prevButton,
                    nextEl: self.options.nextButton
                },
                pagination: {
                    el: self.options.paginationContainer,
                    type: 'fraction'
                },
                breakpoints: {
                    768: {
                        pagination: {
                            el: self.options.paginationContainer,
                            type: 'bullets'
                        },
                        slidesPerView: 1,
                        spaceBetween: 10
                    },
                    991: {
                        slidesPerView: 2,
                        spaceBetween: 20
                    }
                },
                on: {
                    slideChangeTransitionStart: function () {
                        $("img.lazyload", $(sideTtileCategorySlider.slides)).lazyload(true);
                    }
                }
            });
        },

        initTopTitleSlider: function (slider,sliderId,self) {
            var topTtileCategorySlider = new Swiper(slider,{
                spaceBetween: 20,
                slidesPerView: 4,
                slidesPerGroup: 4,
                navigation:{
                    prevEl: self.options.prevButton,
                    nextEl: self.options.nextButton
                },
                pagination: {
                    el: self.options.paginationContainer,
                    type: 'fraction'
                },
                breakpoints: {
                    768: {
                        pagination: {
                            el: self.options.paginationContainer,
                            type: 'bullets'
                        },
                        slidesPerView: 1,
                        slidesPerGroup: 1,
                        spaceBetween: 10
                    },
                    991: {
                        slidesPerView: 2,
                        slidesPerGroup: 2,
                        spaceBetween: 20
                    }
                },
                on: {
                    slideChangeTransitionStart: function () {
                        $("img.lazyload", $(topTtileCategorySlider.slides)).lazyload(true);
                    }
                }
            });
        },

        initBigImageSlider: function (slider,sliderId,self) {
            var bigImageSlider = new Swiper(slider,{
                slidesPerView: 1,
                slidesPerGroup: 1,
                navigation:{
                    prevEl: self.options.prevButton,
                    nextEl: self.options.nextButton
                },
                pagination: {
                    el: self.options.paginationContainer,
                    type: 'fraction'
                },
                breakpoints: {
                    768: {
                        pagination: {
                            el: self.options.paginationContainer,
                            type: 'bullets'
                        },
                        slidesPerView: 1,
                        slidesPerGroup: 1,
                        spaceBetween: 10
                    }
                },
                on: {
                    slideChangeTransitionStart: function () {
                        $("img.lazyload", $(bigImageSlider.slides)).lazyload(true);
                    }
                }
            });
        }



    });

    return $.filoblu.sliderWidget;
});
